
extern int PasswordDialog (HWND hDlg, int Msg, int wParam, int lParam)
{
	static HWND SystemMenu;
	static HWND PasswordBitStatus;
	static HWND PasswordBits_hWnd;
	static HWND PasswordEdit_hWnd;
	static HWND InfoTextStatic_hWnd;

	float PasswordLen = 0;
	float PasswordBits = 0;
	float EffeciencyBits = 0;

	char LocalTemp[257];

	DWORD TopMost = 0;

	for(;;)
	{
		// --------------------------------------

		if(Msg==WM_INITDIALOG)
		{
			PasswordDialog_hWnd = hDlg;

			/* Get TopMost Value From Registry */
			if(GetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\PasswordDialog","TopMost",TopMost))
			{
				if(TopMost == 1) // If Window Is Supposed To Be TopMost
				{
					CheckDlgButton(PasswordDialog_hWnd, 105, BST_CHECKED);
					SetWindowPos(PasswordDialog_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
				}
			}
			else{ // If Key Not Found Create Key And Value
					CreateKey(HKEY_CLASSES_ROOT,"128File\\AppInfo\\PasswordDialog");
					SetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\PasswordDialog","TopMost",1);
					CheckDlgButton(PasswordDialog_hWnd, 105, BST_CHECKED);
					SetWindowPos(PasswordDialog_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
			}

			/* Get SystemMenu Handle | Delete & Append Menu Items */
			SystemMenu = GetSystemMenu(PasswordDialog_hWnd,FALSE);
			DeleteMenu(SystemMenu, SC_SIZE, MF_BYCOMMAND);
			DeleteMenu(SystemMenu, SC_MAXIMIZE, MF_BYCOMMAND);
			AppendMenu(SystemMenu,MF_SEPARATOR,0,0);
			AppendMenu(SystemMenu,MF_STRING,VersionInfo,"Version");

			/* Set Window Icon And Caption */
			SendMessage(PasswordDialog_hWnd, WM_SETICON, TRUE,(LPARAM)LoadIcon(GetWindowInstance(PasswordDialog_hWnd), MAKEINTRESOURCE(1)));
			SendMessage(PasswordDialog_hWnd, WM_SETTEXT, FALSE,(LPARAM)TitleCaption);

			CenterWindow(PasswordDialog_hWnd);

			/* Get Dialog Item Handles */
			PasswordBitStatus = GetDlgItem(PasswordDialog_hWnd,1000);
			PasswordBits_hWnd = GetDlgItem(PasswordDialog_hWnd,2000);
			InfoTextStatic_hWnd = GetDlgItem(PasswordDialog_hWnd,101);
			PasswordEdit_hWnd = GetDlgItem(PasswordDialog_hWnd,500);

			SetTimer(PasswordDialog_hWnd,1,1000,NULL);

			if(Encrypt)
				SetText(InfoTextStatic_hWnd,"Enter A Password To Be Used To Encrypt This Data");
			if(Decrypt)
				SetText(InfoTextStatic_hWnd,"Enter The Password That Was Used To Encrypt This Data.");
			if(Pack)
				SetText(InfoTextStatic_hWnd,"Enter A Password To Be Used To Pack This Data.");
			if(Unpack)
				SetText(InfoTextStatic_hWnd,"Enter The Password That Was Used To Pack This Data.");

			/* Enable Password Bit Status Information If Encrypting */
			if(Encrypt || Pack)
			{
				EnableWindow(PasswordBitStatus,TRUE);
				EnableWindow(PasswordBits_hWnd,TRUE);
				EnableWindow(GetDlgItem(PasswordDialog_hWnd,1500),TRUE);
			}

			break;
		}

		// --------------------------------------

		if(Msg == 307) // Key Down
		{
			PasswordLen = SendMessage(PasswordEdit_hWnd, WM_GETTEXTLENGTH,0,0);

			if(PasswordLen >= 4)EnableWindow(GetDlgItem(PasswordDialog_hWnd,103),TRUE);
			if(PasswordLen <  4)EnableWindow(GetDlgItem(PasswordDialog_hWnd,103),FALSE);

			if(Encrypt || Pack)
			{
				EffeciencyBits = (PasswordLen / 70) * 100;
				SendMessage(PasswordBitStatus, PBM_SETPOS,EffeciencyBits,0);

				PasswordBits = (PasswordLen * 8); /* 8-Bits Per Char */
				sprintf(LocalTemp,"(%.0f Bits)",PasswordBits);
				SetText(PasswordBits_hWnd,LocalTemp);
			}

		}

		// --------------------------------------

		/* Help Button Or User Presses F1 */
		if( (Msg == WM_COMMAND && wParam == 102)  || (Msg == WM_HELP) )
		{
			char HelpFile[1024];
			unsigned long SizeOfHelpFile = sizeof(HelpFile);
			/* Get 128Gamma HelpPath */
			if(GetStringValue(HKEY_CLASSES_ROOT,"128File\\AppInfo","HelpPath",HelpFile,SizeOfHelpFile))
			{
				if(FAccess(HelpFile,0)) // If Help File Exist
				{
					SetWindowPos(PasswordDialog_hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
					CheckDlgButton(PasswordDialog_hWnd, 105, BST_UNCHECKED);
					ShellExecute(PasswordDialog_hWnd,"open",HelpFile,"","",SW_MAXIMIZE);
				}
				else{ // If Help File Does Not Exist
					MessageBox(PasswordDialog_hWnd, "Help File Not Found. \r\nPlease Reinstall 128Gamma." ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);
				}
			}
			else // If Registry Error Or Key Not Found
				MessageBox(PasswordDialog_hWnd, "Registry Key Not Found. \r\nPlease Reinstall 128Gamma." ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);

			SetFocus(PasswordEdit_hWnd);
		}

		// --------------------------------------

		if(Msg == WM_COMMAND)
		{
			if(wParam==105) // Always On Top
			{
				if(IsDlgButtonChecked(PasswordDialog_hWnd, 105))
				{
					SetWindowPos(PasswordDialog_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
					SetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\PasswordDialog","TopMost",1);
					SetFocus(PasswordEdit_hWnd);
				}
				else{
					SetWindowPos(PasswordDialog_hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
					SetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\PasswordDialog","TopMost",0);
					SetFocus(PasswordEdit_hWnd);
				}
			}

			if(wParam == 103) // Ok
			{
				CodedKey = GetText(PasswordEdit_hWnd);

				/* Create StatusDialog Thread */
				StatusDialog_Thread_Handle = CreateThread(NULL,0,StatusDialog_Thread,(LPVOID)0,0,&StatusDialog_Thread_ID);

				while(!StatusText_hWnd) //-- Wait For StatusText_hWnd
				{sleep(10);}
				while(!StatusBar_hWnd)	//-- Wait For StatusBar_hWnd
				{sleep(10);}

				if(Encrypt) //Encrypt
				{
					Update_LastUsed();
					ShowWindow(PasswordDialog_hWnd,FALSE);
					EncryptProcess_Thread_Handle = CreateThread(NULL,0,EncryptProcess_Thread,(LPVOID)0,0,&EncryptProcess_Thread_ID);
				}

				if(Decrypt) //Decrypt
				{
					Update_LastUsed();
					ShowWindow(PasswordDialog_hWnd,FALSE);
					DecryptProcess_Thread_Handle = CreateThread(NULL,0,DecryptProcess_Thread,(LPVOID)0,0,&DecryptProcess_Thread_ID);
				}

				if(Pack) //PackFiles
				{
					Update_LastUsed();
					ShowWindow(PasswordDialog_hWnd,FALSE);
					PackProcess_Thread_Handle = CreateThread(NULL,0,PackProcess_Thread,(LPVOID)0,0,&PackProcess_Thread_ID);
				}

				if(Unpack) //UnpackFiles
				{
					Update_LastUsed();
					ShowWindow(PasswordDialog_hWnd,FALSE);
					UnpackProcess_Thread_Handle = CreateThread(NULL,0,UnpackProcess_Thread,(LPVOID)0,0,&UnpackProcess_Thread_ID);
				}

			}

			if(wParam == 104) //Cancel
			{
				CleanUp(0,1);
				EndDialog(PasswordDialog_hWnd,0);
			}

			if(wParam==106) //Open About Dialog
			{
				ShowWindow(PasswordDialog_hWnd,FALSE);
				DialogBox(hInstance,MAKEINTRESOURCE(1000),PasswordDialog_hWnd,AboutDialog);
				ShowWindow(PasswordDialog_hWnd,TRUE);
				SetFocus(PasswordEdit_hWnd);
			}
			break;
		}

		// --------------------------------------

		if(Msg == WM_TIMER)
		{
			if(Verifiy)
			{
				CleanUp(0,1);
				EndDialog(PasswordDialog_hWnd,0);
				if(!DoneFlag)DoneFlag = 1;
			}
		}

		// --------------------------------------

		if(Msg == WM_SYSCOMMAND)
		{
			if(LOWORD(wParam) == VersionInfo)
			{
				MessageBox(PasswordDialog_hWnd, GammaVersion, TitleCaption, 0 + MB_ICONASTERISK + MB_TASKMODAL);
			}
		}

		// --------------------------------------

		if(Msg == WM_CLOSE) //Close Dialog
		{
			CleanUp(0,1);
			EndDialog(PasswordDialog_hWnd,0);
		}

		// --------------------------------------

		break;
	}
	return 0;
}

