/*
 Functions.H - Main 128Gamma Functions File

extern void Error(char *Message)
extern int CleanUp(int Kill, int Delete)
extern int Encrypted(char *FileToCheck)
extern int SetTempVariables(void)
extern char *GetTempDirectory(void)
extern void SetText (HWND hDlg, char *Txt)
extern char *GetText (HWND hDlg)
extern void CenterWindow (HWND hWnd)
extern int EncryptProcess(void)
extern int DecryptProcess(void)
extern int PackProcess(void)
extern int UnpackProcess(void)
extern int ProcessInput(char *xInput)
extern int CancelProcess(void)
extern int Backup(void)
extern DWORD FileSize(char *File2Size)
extern void ClearBuffer(void)
extern DWORD WINAPI StatusDialog_Thread(LPVOID data)
extern DWORD WINAPI EncryptProcess_Thread(LPVOID data)
extern DWORD WINAPI DecryptProcess_Thread(LPVOID data)
extern DWORD WINAPI PackProcess_Thread(LPVOID data)
extern DWORD WINAPI UnpackProcess_Thread(LPVOID data)
extern BOOL FAccess(char *FileName, short Mode)
extern char *Get_Time(void)
extern char *Get_LongDate(void)
extern char *Get_UserName(void)
extern void Update_LastUsed(void)
extern void Clear_ReadTemp(void)
extern void FreeMemory(void)
extern void SetPriority(void)
*/

//--------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////

extern void Error(char *Message)
{
	KillFlag = 1;
	MessageBox (GetActiveWindow(), Message ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);
	CleanUp(1,1);
}

//////////////////////////////////////////////////////////////////////

extern int CleanUp(int Kill, int Delete)
{
	if(Delete)
	{
		_fcloseall(); //Attempt To Close All Open Files... (If Any)
		unlink(EncryptTemp);
		unlink(PackTemp);
		unlink(BackupTemp);
	}

	if(Kill)
	{
		_fcloseall(); //Attempt To Close All Open Files... (If Any)
		sleep(500); // Hopfully Give Time For Files To Reset Or Flush.
		unlink(EncryptTemp);
		unlink(PackTemp);
		unlink(BackupTemp);
		exit(0);
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int Encrypted(char *FileToCheck)
{
	FILE * FileToCheck_File;

	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL)
		Error("Could Not Open Source For Read. Error: 14.");

	fread(Buffer,sizeof(char),10,FileToCheck_File);

	if(strcmp(Buffer,ENCFlag) == 0)
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		End_Of_File = 0;
		return 1;
	}

	if(strcmp(Buffer,PACFlag) == 0)
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		End_Of_File = 0;
		return 2;
	}

	if(FileToCheck_File)
		fclose(FileToCheck_File);
	return 3;
}

//////////////////////////////////////////////////////////////////////

extern int SetTempVariables(void)
{
	sprintf(EncryptTemp,"%s\\%s",GetTempDirectory(),"Encrypt.128G");
	sprintf(PackTemp,"%s\\%s",GetTempDirectory(),"Pack.128G");
	sprintf(BackupTemp,"%s\\%s",GetTempDirectory(),"Backup.128G");
	if(!BackupTemp)
		return 1;
	if(!EncryptTemp)
		return 1;
	if(!PackTemp)
		return 1;
	return 0;
}

//////////////////////////////////////////////////////////////////////

extern char *GetTempDirectory(void)
{
	static char StrFunction [64][257] = {'\0'};
	int StrCnt = 0;
	char T[257] = {'\0'};
	GetTempPath (256,T);
	if (++StrCnt==64) StrCnt = 0;
	sprintf(StrFunction[StrCnt],"%s",T);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

extern void SetText (HWND hDlg, char *Txt)
{
	SendMessage(hDlg,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)Txt);
}

/////////////////////////////////////////////////////////////////////

extern char *GetText (HWND hDlg)
{
	int StrCnt = 0;
	int T = 0;
	char xBuffer[2048] = {'\0'};
	LPSTR StrFunc[16] = {'\0'};
	if (++StrCnt==16) StrCnt = 0;
	if (StrFunc[StrCnt]) free (StrFunc[StrCnt]);
	StrFunc[StrCnt] = (char*) malloc (2048);
	memset (StrFunc[StrCnt],0,2048);
	T=GetWindowTextLength(hDlg);
	GetWindowText(hDlg,xBuffer,T+1);
	sprintf(StrFunc[StrCnt],"%s",xBuffer);
	return StrFunc[StrCnt];
}
/////////////////////////////////////////////////////////////////////

extern void CenterWindow (HWND hWnd)
{
	static RECT wRect;
	DWORD x = 0;
	DWORD y = 0;
	GetWindowRect(hWnd,&wRect);
	x=(GetSystemMetrics(SM_CXSCREEN)-(wRect.right-wRect.left))/2;
	y=(GetSystemMetrics(SM_CYSCREEN)-(wRect.bottom-wRect.top+GetSystemMetrics(SM_CYCAPTION)))/2;
	SetWindowPos(hWnd,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
}

/////////////////////////////////////////////////////////////////////

extern int EncryptProcess(void)
{
	float xFileSize = 0;
	char StatusTemp[1024];
	CleanUp(0,1);

	if(Backup())
	{
		Status = "Backup Failed...";
		DoneFlag = 1;
		CleanUp(0,1);
		return(0);
	}

	xFileSize = FileSize(GlobalFileName);
	sprintf(StatusTemp,"Ciphering %.1f MB",xFileSize/1024/1024);
	Status = StatusTemp;
	if(Cipher(GlobalFileName,EncryptTemp,CodedKey))
	{
		xFileSize = FileSize(EncryptTemp);
		sprintf(StatusTemp,"Encoding %.1f MB",xFileSize/1024/1024);
		Status = StatusTemp;
		if(IncodeMain(EncryptTemp,GlobalFileName))
		{
			Status = "Data Successfully Encrypted!";
		}

	}

	CleanUp(0,1);
	DoneFlag = 1;
	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int DecryptProcess(void)
{
	float xFileSize = 0;
	char StatusTemp[1024];
	CleanUp(0,1);

	if(Backup())
	{
		Status = "Backup Failed...";
		DoneFlag = 1;
		CleanUp(0,1);
		return(0);
	}

	xFileSize = FileSize(GlobalFileName);
	sprintf(StatusTemp,"Decoding %.1f MB",xFileSize/1024/1024);
	Status = StatusTemp;
	if(DecodeMain(GlobalFileName,EncryptTemp))
	{
		xFileSize = FileSize(EncryptTemp);
		sprintf(StatusTemp,"Deciphering %.1f MB",xFileSize/1024/1024);
		Status = StatusTemp;
		if(Decipher(EncryptTemp,GlobalFileName,CodedKey))
		{
			Status = "Data Successfully Decrypted!";
		}
	}

	CleanUp(0,1);
	DoneFlag = 1;

	return(0);
}

//////////////////////////////////////////////////////////////////////

extern int PackProcess(void)
{
	char OutputFile[1024];
	char StatusTemp[1024];
	float xFileSize = 0;

	CleanUp(0,1);
	sprintf(OutputFile,"%s.128",GlobalFileName);

	Status = "Reading Files And Folders...";
	if(PackFiles(GlobalFileName,PackTemp))
	{
		xFileSize = FileSize(PackTemp);
		sprintf(StatusTemp,"Ciphering %.1f MB",xFileSize/1024/1024);
		Status = StatusTemp;
		/* EnCode(Source,Target,Password); */
		if(Cipher(PackTemp,EncryptTemp,CodedKey))
		{
			xFileSize = FileSize(EncryptTemp);
			sprintf(StatusTemp,"Encoding %.1f MB",xFileSize/1024/1024);
			Status = StatusTemp;
			/* IncodeMain(Source,Target); */
			if(IncodeMain(EncryptTemp,OutputFile))
			{
				Status = "Data Successfully Packed!";
			}
		}
	}
	if(CancelFlag)
		unlink(OutputFile);

	DoneFlag = 1;
	CleanUp(0,1);

	return(0);
}

//////////////////////////////////////////////////////////////////////

extern int UnpackProcess(void)
{
	char StatusTemp[1024];
	float xFileSize = 0;
	char xFile[257];

	CleanUp(0,1);

	_splitpath(GlobalFileName,NULL,NULL,xFile,NULL);

	xFileSize = FileSize(GlobalFileName);
	sprintf(StatusTemp,"Decoding %.1f MB",xFileSize/1024/1024);
	Status = StatusTemp;
	if(DecodeMain(GlobalFileName,EncryptTemp))
	{
		xFileSize = FileSize(EncryptTemp);
		sprintf(StatusTemp,"Deciphering %.1f MB",xFileSize/1024/1024);
		Status = StatusTemp;
		if(Decipher(EncryptTemp,PackTemp,CodedKey))
		{
			CreateDirectory(xFile,0);
			if(UnPackFiles(PackTemp,xFile))
			{
				Status = "Data Successfully Unpacked!";
			}
		}
	}

	DoneFlag = 1;
	CleanUp(0,1);

	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int ProcessInput(char *xInput)
{
	short ENCMethod = 0;
	unsigned int Attrib = 0;

	if(strlen(xInput) > 0) // If Any Program Input Params
	{
		char Extention[27];
		char xDrive[7];
		char xPath[257];
		_splitpath(xInput,xDrive,xPath,NULL,Extention);

		sprintf(GlobalFileName,"%s",xInput);

		/* Get Input File Attributes */
		Attrib = GetFileAttributes(GlobalFileName);

		/* If ReadOnly... Prompt User */
		if(Attrib & FILE_ATTRIBUTE_READONLY)
		{
			if(MessageBox(GetActiveWindow(),"This File Is ReadOnly.\r\nSet To Normal Access? ",TitleCaption,4+256+MB_ICONQUESTION + MB_SYSTEMMODAL) != 6)
				return 0;
			SetFileAttributes(xInput,FILE_ATTRIBUTE_NORMAL);
		}

		/* Check For File Access */
		if(!FAccess(xInput,0))
			Error("File Does Not Exist. Error 15.");
		if(!FAccess(xInput,2))
			Error("File Does Not Allow Write Access. Error 16.");
		if(!FAccess(xInput,4))
			Error("File Does Not Allow Read Access. Error 17.");
		if(!FAccess(xInput,6))
			Error("File Does Not Allow Read Or Write Access. Error 18.");

		/* If Input Point To A Folder */
		if(Attrib & FILE_ATTRIBUTE_DIRECTORY)
		{
			/* If Directory Name Is 3 Char Long  ( c:\ d:\ ) */
			if(strlen(xInput) == 3)
			{
				MessageBox(GetActiveWindow(),"128Gamma Does Not Have Support For Full Drives At This Time.",TitleCaption,+ MB_SYSTEMMODAL);
				return 0;
			}

			Pack = 1;
			Unpack = 0;
			Decrypt = 0;
			Encrypt = 0;

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		/* If Extention Is .128 */
		if( strcmp(Extention,".128") == 0 )
		{
			Unpack = 1;
			Pack = 0;
			Decrypt = 0;
			Encrypt = 0;

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		/* ENCMethod ( 1 = Encrypted , 2 = Packed , 3 = NOT Encrypted) */

		ENCMethod = Encrypted(GlobalFileName);

		if(ENCMethod == 1) // Encrypted
		{
			Decrypt = 1;
			Encrypt = 0;
			Unpack = 0;
			Pack = 0;

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 2) //  Packed
		{
			Unpack = 1;
			Decrypt = 0;
			Encrypt = 0;
			Pack = 0;

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 3) // NOT Encrypted
		{
			Encrypt = 1;
			Unpack = 0;
			Decrypt = 0;
			Pack = 0;

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}
	}

	CleanUp(0,1);

	return 1;
}

/////////////////////////////////////////////////////////////////////

extern int CancelProcess(void)
{
	if(Pack || Unpack)return 0;

	Status = "Restoring Source File.";
	long double SourceFileSize = 0;
	long double Current_Size = 0;
	int SentSize = 0;
	FILE *Source, *Target;

	SourceFileSize = FileSize(BackupTemp);
	if(SourceFileSize == -1)
	{
		Error("File Size Error. Error 20.");
		DoneFlag = 1;
		CleanUp(0,1);
		return(0);
	}

	if((Source = fopen(BackupTemp,"rb")) == NULL)
	{
		if(Source)fclose(Source);
		return 0;
	}

	if((Target = fopen(GlobalFileName,"wb")) == NULL)
	{
		if(Source)fclose(Source);
		if(Target)fclose(Target);
		unlink(BackupTemp);
		return 0;
	}

	do
	{
		SentSize = fread(Buffer,sizeof(char),BufferSize,Source);
		fwrite(Buffer,sizeof(char),SentSize,Target);

		Current_Size += SentSize;
		StatusValue = (Current_Size / SourceFileSize) * 100;

	}
	while(SentSize == BufferSize);

	if(Source)fclose(Source);
	if(Target)fclose(Target);

	return 0;
}

/////////////////////////////////////////////////////////////////////

extern int Backup(void)
{
	long double SourceFileSize = 0;
	long double Current_Size = 0;
	int SentSize = 0;
	FILE *Source, *Target;
	Status = "Backing Up Source File.";
	SourceFileSize = FileSize(GlobalFileName);
	if(SourceFileSize == -1)
	{
		Error("File Size Error. Error 21.");
		DoneFlag = 1;
		CleanUp(0,1);
		return(0);
	}

	if((Source = fopen(GlobalFileName,"rb")) == NULL)
	{
		if(Source)fclose(Source);
		return 0;
	}

	if((Target = fopen(BackupTemp,"wb")) == NULL)
	{
		if(Source)fclose(Source);
		if(Target)fclose(Target);
		unlink(BackupTemp);
		return 0;
	}

	do
	{
		if(CancelFlag)
		{
			if(Source)fclose(Source);
			if(Target)fclose(Target);
			unlink(BackupTemp);
			CleanUp(0,1);
			return 0;
		}

		SentSize = fread(Buffer,sizeof(char),BufferSize,Source);
		fwrite(Buffer,sizeof(char),SentSize,Target);

		Current_Size += SentSize;
		StatusValue = (Current_Size / SourceFileSize) * 100;
	}
	while(SentSize == BufferSize);

	if(Source)fclose(Source);
	if(Target)fclose(Target);
	return 0;
}

/////////////////////////////////////////////////////////////////////

extern DWORD FileSize(char *File2Size)
{
	FILE *Source;
	DWORD size;
	SetFileAttributes(File2Size,FILE_ATTRIBUTE_NORMAL);
	Source = CreateFile(File2Size,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
	size = GetFileSize(Source,NULL);
	if(size == HFILE_ERROR)return -1;
	CloseHandle(Source);
	return size;
}

///////////////////////////////////////////////////////////////////////

extern void ClearBuffer(void)
{
	int LocalLoop;
	LocalLoop = 0;
	while(LocalLoop < sizeof(Buffer))
	{
		Buffer[LocalLoop] = '\0';
		LocalLoop++;
	}
}

///////////////////////////////////////////////////////////////////////

extern DWORD WINAPI StatusDialog_Thread(LPVOID data)
{
	DialogBox(hInstance,MAKEINTRESOURCE(200),0,StatusDialog);
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI EncryptProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);
	EncryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI DecryptProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);
	DecryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI PackProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);
	PackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI UnpackProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);
	UnpackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern char *Get_Time()
{
	static SYSTEMTIME st;			   //SystemTime
	static char t [257];			   //SystemTime (Time)
	GetLocalTime(&st);
	GetTimeFormat(LOCALE_USER_DEFAULT,TIME_NOSECONDS,&st,NULL,t,64);
	return (t);
}

//////////////////////////////////////////////////////////////////////

extern char *Get_LongDate ()
{
	static SYSTEMTIME st;			   //SystemTime
	static char d [257];			   //SystemTime (LONG Date)
	GetLocalTime(&st);
	GetDateFormat(LOCALE_USER_DEFAULT,DATE_LONGDATE,&st,NULL,d,64);
	return (d);
}

//////////////////////////////////////////////////////////////////////

extern char *Get_UserName ()
{
	static char StrFunction [64][257];
	static int StrCnt;
	static char A[257];
	static DWORD b;
	if (++StrCnt==64) StrCnt = 0;
	b=256;
	GetUserName(A,&b);
	sprintf(StrFunction[StrCnt],"%s",A);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

/*
6	Check for read and write permission
4	Check for read permission
2	Check for write permission
1	Execute (ignored)
0	Check for existence of file
*/

extern BOOL FAccess(char *FileName, short Mode)
{
	if(access(FileName, Mode) == 0)
		return 1;
	return 0;
}

//////////////////////////////////////////////////////////////////////

extern void Update_LastUsed(void)
{
	SetStringValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\LastRun","User",Get_UserName());
	SetStringValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\LastRun","Date",Get_LongDate());
	SetStringValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\LastRun","Time",Get_Time());
}

//////////////////////////////////////////////////////////////////////

extern void FreeMemory(void)
{
	while(FolderCount != 0)
	{
		free(FolderNames[FolderCount]);
		FolderNames[FolderCount] = '\0';
		FolderCount--;
	}
	while(FileCount != 0)
	{
		free(FileNames[FileCount]);
		FileNames[FolderCount] = '\0';
		FileCount--;
	}
}

///////////////////////////////////////////////////////////////////////

extern void Clear_ReadTemp(void)
{
	int LocalLoop = 0;
	while(LocalLoop < sizeof(ReadTemp))
	{
		ReadTemp[LocalLoop] = '\0';
		LocalLoop++;
	}
}

//////////////////////////////////////////////////////////////////////

extern BOOL SetPriority(void)
{
	DWORD Priority = 0;
	BOOL HighOrRealTime = FALSE;
	HANDLE CurrentProcessHandle = GetCurrentProcess();
	HANDLE CurrentThreadHandle = GetCurrentThread();

	if(GetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\Priority","Process",Priority))
	{
		if(Priority == 1)SetPriorityClass(CurrentProcessHandle,IDLE_PRIORITY_CLASS);
		if(Priority == 2)SetPriorityClass(CurrentProcessHandle,NORMAL_PRIORITY_CLASS);
		if(Priority == 3)SetPriorityClass(CurrentProcessHandle,HIGH_PRIORITY_CLASS);
		if(Priority == 4)SetPriorityClass(CurrentProcessHandle,REALTIME_PRIORITY_CLASS);
		if(Priority > 2)HighOrRealTime = TRUE;
	}
	else SetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\Priority","Process",2);

	Priority = 0;

	if(GetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\Priority","Thread",Priority))
	{
		if(Priority == 1)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_IDLE);
		if(Priority == 2)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_LOWEST);
		if(Priority == 3)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_BELOW_NORMAL);
		if(Priority == 4)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_NORMAL);
		if(Priority == 5)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_ABOVE_NORMAL);
		if(Priority == 6)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_HIGHEST);
		if(Priority == 7)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_TIME_CRITICAL);
		if(Priority > 5)HighOrRealTime = TRUE;
	}
	else SetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\Priority","Thread",4);

	if(HighOrRealTime == TRUE)
	{
		if(MessageBox(StatusDialog_hWnd,"128Gamma Is Running In High, RealTime Or TimeCritical Mode. \r\nThis Severly Cripples Windows Performance. \r\nContinue Anyway? ",TitleCaption,4+256+MB_ICONQUESTION + MB_SYSTEMMODAL) != 6)
		{
			CancelFlag = TRUE;
			DoneFlag = 1;
			return TRUE;
		}
	}

	Priority = 0;

	if(GetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\Priority","ThreadBoost",Priority))
	{
		if(Priority == 0)SetThreadPriorityBoost(CurrentThreadHandle,TRUE); //Disable Boost
		if(Priority == 1)SetThreadPriorityBoost(CurrentThreadHandle,FALSE); //Enable Boost
	}
	else SetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\Priority","ThreadBoost",1);

	Priority = 0;

	if(GetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\Priority","ProcessBoost",Priority))
	{
		if(Priority == 0)SetProcessPriorityBoost(CurrentProcessHandle,TRUE); //Disable Boost
		if(Priority == 1)SetProcessPriorityBoost(CurrentProcessHandle,FALSE); //Enable Boost
	}
	else SetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\Priority","ProcessBoost",1);

	return FALSE;
}

//////////////////////////////////////////////////////////////////////

